<template>
    <el-card>
        <h1 slot="header">{{$t("trend.header")}}</h1>
        <el-row>
            <el-col :span="12">
                <bar class="chart"
                    :styles="{position:'block', 'width':'100%', 'height':'20em'}"
                    ref="graph"></bar>
                <el-collapse v-model="opened">
                    <el-collapse-item :title="$t('trend.details')" name="1">
                        <el-table :data='tableData' style="width: 100%">
                            <el-table-column prop="name"
                                label="Name"
                                :sortable="false"
                                :width="200"></el-table-column>
                            <el-table-column
                                prop="surname"
                                label="Surname"
                                :sortable="false"
                                :width="200"></el-table-column>
                            <el-table-column
                                prop="age"
                                label="Age"
                                :sortable="false"
                                :width="200"></el-table-column>
                            <el-table-column
                                prop="nickname"
                                label="Nickname"
                                :sortable="false"
                                :width="200"></el-table-column>
                            <el-table-column
                                prop="birth"
                                label="Year birth"
                                :sortable="false"
                                :width="200"></el-table-column>
                        </el-table>
                    </el-collapse-item>
                </el-collapse>
            </el-col>
        </el-row>
    </el-card>
</template>
<script>
"use strict";

import {Bar} from "vue-chartjs";
import PluginZoom from "chartjs-plugin-zoom";
import HammerJs from "hammerjs";

export default {
    name: "Trend",
    components: {Bar},
    computed: {
        rangeMax() {
            return Math.max(...this.graphData.datasets[0].data);
        }
    },
    data() {
        return {
            opened: [],
            tableData: [
                {
                    name: "Rodolfo",
                    surname: "Bevione",
                    age: 26,
                    nickname: "rododo93",
                    email: "rodolfo.bevione@gmail.com",
                    birth: 1993
                },
                {
                    name: "Emanuele",
                    surname: "Forneris",
                    age: 24,
                    nickname: "fornaro",
                    email: "eforneris@kpmg.it",
                    birth: 1996
                },
                {
                    name: "Ilaria",
                    surname: "Rinaldo",
                    age: 25,
                    nickname: "Iaia",
                    email: "ilaria.condizionata@live.com",
                    birth: 1994
                }
            ],
            graphData: {
                labels: [
                    "January",
                    "February",
                    "March",
                    "April",
                    "May",
                    "June",
                    "July",
                    "August",
                    "September",
                    "October",
                    "November",
                    "December"
                ],
                datasets: [
                    {
                        label: "GitHub Commits",
                        backgroundColor: "#f87979",
                        data: [40, 20, 12, 39, 10, 40, 39, 80, 40, 20, 12, 11]
                    }
                ]
            }
        };
    },
    methods: {
        renderChart() {
            this.$refs.graph.renderChart(
                this.graphData,
                {
                    responsive: true,
                    maintainAspectRatio: false,
                    plugins: {
                        zoom: {
                            pan: {
                                enabled: true,
                                mode: "y",
                                rangeMin: {
                                    x: 0,
                                    y: 0
                                },
                                rangeMax: {
                                    x: null,
                                    y: this.rangeMax
                                }
                            },

                            // Container for zoom options
                            zoom: {
                                enabled: true,
                                drag: false,
                                mode: "y",
                                rangeMin: {
                                    x: 0,
                                    y: 0
                                },
                                rangeMax: {
                                    x: null,
                                    y: this.rangeMax
                                },
                                speed: 0.1,
                            }
                        }
                    }
                }
            );
        }
    },
    mounted() {
        this.renderChart();
    }
};
</script>
